Package org.bukkit.event.block

# Class SignChangeEvent

java.lang.Object
org.bukkit.event.Event
org.bukkit.event.block.BlockEvent
org.bukkit.event.block.SignChangeEvent

All Implemented Interfaces:
  `Cancellable`

public class SignChangeEvent extends BlockEvent implements Cancellable
Called when a sign is changed by a player.

If a Sign Change event is cancelled, the sign will not be changed.

## Nested Class Summary

## Nested classes/interfaces inherited from class org.bukkit.event.Event

`Event.Result`

## Field Summary

### Fields inherited from class org.bukkit.event.block.BlockEvent

`block`

## Constructor Summary

Constructors
Constructor
Description
`SignChangeEvent(@NotNull Block theBlock, @NotNull Player thePlayer, @NotNull String[] theLines)`
Deprecated.
`SignChangeEvent(@NotNull Block theBlock, @NotNull Player player, List<Component> adventure$lines)`

## Method Summary

Modifier and Type
Method
Description
`static @NotNull HandlerList`
`getHandlerList()`
`@NotNull HandlerList`
`getHandlers()`
`@Nullable String`
`getLine(int index)`
Deprecated.
in favour of `line(int)`
`@NotNull String[]`
`getLines()`
Deprecated.
in favour of `lines()`
`@NotNull Player`
`getPlayer()`
Gets the player changing the sign involved in this event.
`boolean`
`isCancelled()`
Gets the cancellation state of this event.
`Component`
`line(int index)`
Gets a single line of text from the sign involved in this event.
`void`
`line(int index, Component line)`
Sets a single line for the sign involved in this event
`List<Component>`
`lines()`
Gets all of the lines of text from the sign involved in this event.
`void`
`setCancelled(boolean cancel)`
Sets the cancellation state of this event.
`void`
`setLine(int index, @Nullable String line)`
Deprecated.
in favour of `line(int, net.kyori.adventure.text.Component)`

### Methods inherited from class org.bukkit.event.block.BlockEvent

`getBlock`

### Methods inherited from class org.bukkit.event.Event

`callEvent, getEventName, isAsynchronous`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### SignChangeEvent

public SignChangeEvent(@NotNull @NotNull Block theBlock, @NotNull @NotNull Player player, @NotNull List<Component> adventure$lines)

### SignChangeEvent

@Deprecated public SignChangeEvent(@NotNull @NotNull Block theBlock, @NotNull @NotNull Player thePlayer, @NotNull @NotNull String[] theLines)
Deprecated.

## Method Details

### getPlayer

@NotNull public @NotNull Player getPlayer()
Gets the player changing the sign involved in this event.

Returns:
  the Player involved in this event

### lines

@NotNull public List<Component> lines()
Gets all of the lines of text from the sign involved in this event.

Returns:
  the String array for the sign's lines new text

### line

@Nullable public Component line(int index) throws IndexOutOfBoundsException
Gets a single line of text from the sign involved in this event.

Parameters:
  `index` - index of the line to get
Returns:
  the String containing the line of text associated with the provided index
Throws:
  `IndexOutOfBoundsException` - thrown when the provided index is > 3 or < 0

### line

public void line(int index, @Nullable Component line) throws IndexOutOfBoundsException
Sets a single line for the sign involved in this event

Parameters:
  `index` - index of the line to set
  `line` - text to set
Throws:
  `IndexOutOfBoundsException` - thrown when the provided index is > 3 or < 0

### getLines

@NotNull @Deprecated public @NotNull String[] getLines()
Deprecated.
in favour of `lines()`
Gets all of the lines of text from the sign involved in this event.

Returns:
  the String array for the sign's lines new text

### getLine

@Nullable @Deprecated public @Nullable String getLine(int index) throws IndexOutOfBoundsException
Deprecated.
in favour of `line(int)`
Gets a single line of text from the sign involved in this event.

Parameters:
  `index` - index of the line to get
Returns:
  the String containing the line of text associated with the provided index
Throws:
  `IndexOutOfBoundsException` - thrown when the provided index is > 3 or < 0

### setLine

@Deprecated public void setLine(int index, @Nullable @Nullable String line) throws IndexOutOfBoundsException
Deprecated.
in favour of `line(int, net.kyori.adventure.text.Component)`
Sets a single line for the sign involved in this event

Parameters:
  `index` - index of the line to set
  `line` - text to set
Throws:
  `IndexOutOfBoundsException` - thrown when the provided index is > 3 or < 0

### isCancelled

public boolean isCancelled()
Description copied from interface: `Cancellable`
Gets the cancellation state of this event. A cancelled event will not be executed in the server, but will still pass to other plugins

Specified by:
  `isCancelled` in interface `Cancellable`
Returns:
  true if this event is cancelled

### setCancelled

public void setCancelled(boolean cancel)
Description copied from interface: `Cancellable`
Sets the cancellation state of this event. A cancelled event will not be executed in the server, but will still pass to other plugins.

Specified by:
  `setCancelled` in interface `Cancellable`
Parameters:
  `cancel` - true if you wish to cancel this event

### getHandlers

@NotNull public @NotNull HandlerList getHandlers()

Specified by:
  `getHandlers` in class `Event`

### getHandlerList

@NotNull public static @NotNull HandlerList getHandlerList()